/*
 * LED Matrix ansteuern
 *
 * PortA 0-7	Spalten Daten
 * PortC 0-3	Spalten Select
 * PortC 4-7	Zeilen Select
 * PortB 0-2	Platinen Select
 * PortB 4		Spalten Disable
 * PortB 3		Zeilen Disable
 *
 * Created: 09.08.2011 16:00:00
 *  Author: Basti
 */ 

 .include "m1284Pdef.inc"

 ; .equ definiert ein Symbol und dessen Wert
 ; Taktfrequenz
.equ XTAL  = 18432000

.equ DATEN_PORT = PORTA
.equ DATEN_DDR  = DDRA

; Register
.def temp1 = r16
.def temp2 = r17
.def temp3 = r18

	; Stack setzen
	ldi     temp1, LOW(RAMEND)
	out     SPL, temp1
	ldi     temp1, HIGH(RAMEND)
	out     SPH, temp1

	; Ports initialisieren
	rcall   init_ports	

	; Bild aus EEPROM am Y-Pointer in Bild_akt im SRAM laden
    ldi     YL,LOW(eep_bild1)
	ldi     YH,HIGH(eep_bild1)
	rcall   eep2ram
	
; Schleife zum Anzeigen des	Bildes
; Ein durchgang der Schleife dauert 9978us
loop:   		   
	ldi     temp1, 0x0
loop2:	       
    ; Den Z-Pointer mit dem Start des aktuellen Bildes im SRAM laden
	ldi     r30,LOW(Bild_akt)
	ldi     r31,HIGH(Bild_akt)

	swap    temp1
	add     ZL, temp1                   ; Z-Pointer um Anzahl der Zeilen weiterrcken
	rcall   Zeilen_setzen 
	out     PORTC, temp1
	swap    temp1

	cbi     PORTB, 3                    ; Zeile einschalten
	rcall   delayLED_on
	sbi     PORTB, 3                    ; Zeile ausschalten
	rcall   delayLED_off

	inc     temp1                       ; erhhe das Zaehlregister
	cpi     temp1, 16                   ; mit dem Endwert vergleichen
	brne    loop2

	rjmp    loop

.include "routines.asm"    

; SRAM Datensegment
.DSEG
Bild_akt:                               ; 2kB fr aktuelles Bild reservieren
	.BYTE   2048
Bild_neu:                               ; 2kB fr empfangene Bild reservieren
	.BYTE   2048


; EEPROM fllen
.include "eep.asm"
