	ldi     temp2, 0xFF                 ; 1. Schleife fr jede Platine 256Byte laden
init_ports:
	ldi     temp1, 0xFF                 ; Port A-C als Ausgang
	out     DDRA, temp1
	out     DDRB, temp1
	out     DDRC, temp1

	out     PORTA, temp1                ; Datenport setzen

	ldi     temp2, 0b00011000           ; Spalten / Zeilen ausschalten, erste Platine an
	out     PORTB, temp2

	ldi     temp2, 0x00	                ; Erste Zeile / Spalte auswhlen
	out     PORTC, temp2
	ret

; Von oben nach unten jeweils die aktuellen Zeilen (jede 16.) setzen
Zeilen_setzen:
	push    temp1	   

	; 1. Platine
	ldi     temp1, 0b00011000           ; Platine Adressieren
	out     PORTB, temp1
	rcall   Zeile_ausgeben_oben         ; Zeile ab aktueller Z Position ausgeben

	; 2. Platine
	inc     ZH                          ; Z-Pointer um 16 Zeilen weitersetzen
	sbiw    Z, 0x10                     ; Z-Pointer an den Anfang der Zeile setzen
 	ldi     temp1, 0b00011001           ; Platine Adressieren
	out     PORTB, temp1
	rcall   Zeile_ausgeben_oben         ; Zeile ab aktueller Z Position ausgeben

	; 3. Platine
	inc     ZH
	sbiw    Z, 0x10
	ldi     temp1, 0b00011010
	out     PORTB, temp1
	rcall   Zeile_ausgeben_oben

	; 4. Platine
	inc     ZH
	sbiw    Z, 0x10
	ldi     temp1, 0b00011011
	out     PORTB, temp1
	rcall   Zeile_ausgeben_oben

	; 5. Platine
	inc     ZH
	sbiw    Z, 0x10
	ldi     temp1, 0b00011100
	out     PORTB, temp1
	rcall   Zeile_ausgeben_unten

	; 6. Platine
	inc     ZH
	sbiw    Z, 0x10
	ldi     temp1, 0b00011101
	out     PORTB, temp1
	rcall   Zeile_ausgeben_unten

	; 7. Platine
	inc     ZH
	sbiw    Z, 0x10
	ldi     temp1, 0b00011110
	out     PORTB, temp1
	rcall   Zeile_ausgeben_unten

	; 8. Platine
	inc     ZH
	sbiw    Z, 0x10
	ldi     temp1, 0b00011111
	out     PORTB, temp1
	rcall   Zeile_ausgeben_unten

	pop     temp1
	ret

; Die Zeile ab dem aktuellen Z-Pointer ausgeben
; obere 4 Platinen
Zeile_ausgeben_oben:
	push    temp1
	ld      temp1, Z                    ; Aktuelles Byte aus SRAM laden

	; 1. Byte
	out     PORTA, temp1                ; Byte an PortA ausgeben

	ldi     temp1, 0b00000000           ; Aktuelle 8 Spalten adressieren
	out     PORTC, temp1                ; .. und ausgeben
	ldd     temp1, Z+1                  ; Nchstes Byte aus SRAM laden
	cbi     PORTB, 4                    ; Clock zum bernehmen der Daten
	sbi     PORTB, 4

	; 2. Byte
	out     PORTA, temp1
	
	ldi     temp1, 0b00000001
	out     PORTC, temp1
	ldd     temp1, Z+3
	cbi     PORTB, 4
	sbi     PORTB, 4

	; 4. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000011
	out     PORTC, temp1
	ldd     temp1, Z+2
	cbi     PORTB, 4
	sbi     PORTB, 4

	; 3. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000010
	out     PORTC, temp1
	ldd     temp1, Z+6
	cbi     PORTB, 4
	sbi     PORTB, 4      

	; 7. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000110
	out     PORTC, temp1
	ldd     temp1, Z+7
	cbi     PORTB, 4
	sbi     PORTB, 4     

	; 8. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000111
	out     PORTC, temp1
	ldd     temp1, Z+5
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 6. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000101
	out     PORTC, temp1
	ldd     temp1, Z+4
	cbi     PORTB, 4
	sbi     PORTB, 4 

	; 5. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000100
	out     PORTC, temp1
	ldd     temp1, Z+12
	cbi     PORTB, 4
	sbi     PORTB, 4       

	; 13. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001100
	out     PORTC, temp1
	ldd     temp1, Z+13
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 14. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001101
	out     PORTC, temp1
	ldd     temp1, Z+15
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 16. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001111
	out     PORTC, temp1
	ldd     temp1, Z+14
	cbi     PORTB, 4
	sbi     PORTB, 4 

	; 15. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001110
	out     PORTC, temp1
	ldd     temp1, Z+10
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 11. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001010
	out     PORTC, temp1
	ldd     temp1, Z+11
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 12. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001011
	out     PORTC, temp1
	ldd     temp1, Z+9
	cbi     PORTB, 4
	sbi     PORTB, 4 

	; 10. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001001
	out     PORTC, temp1
	ldd     temp1, Z+8
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 9. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001000
	out     PORTC, temp1
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	adiw    Z,16

	pop     temp1
	ret

; Die Zeile ab dem aktuellen Z-Pointer ausgeben
; untere 4 Platinen
Zeile_ausgeben_unten:
	push    temp1

	ld      temp1, Z                    ; Aktuelles Byte aus SRAM laden	

	; 1. Byte
	out     PORTA, temp1                ; Byte an PortA ausgeben	

	ldi     temp1, 0b00000000           ; Aktuelle 8 Spalten adressieren
	out     PORTC, temp1                ; .. und ausgeben
	ldd     temp1, Z+1                  ; Nchstes Byte aus SRAM laden
	nop                                 ; Pause, um seltsame Anzeigefehler zu vermeiden
	nop
	nop
	nop
	cbi     PORTB, 4                    ; Clock zum bernehmen der Daten
	sbi     PORTB, 4

	; 2. Byte
	out     PORTA, temp1
	
	ldi     temp1, 0b00000001
	out     PORTC, temp1
	ldd     temp1, Z+3
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4

	; 4. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000011
	out     PORTC, temp1
	ldd     temp1, Z+2
	nop
	nop
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4

	; 3. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000010
	out     PORTC, temp1
	ldd     temp1, Z+6
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4      

	; 7. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000110
	out     PORTC, temp1
	ldd     temp1, Z+7
	nop
	nop
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4     

	; 8. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000111
	out     PORTC, temp1
	ldd     temp1, Z+5
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 6. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000101
	out     PORTC, temp1
	ldd     temp1, Z+4
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4 

	; 5. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00000100
	out     PORTC, temp1
	ldd     temp1, Z+12
	nop
	nop
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4       

	; 13. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001100
	out     PORTC, temp1
	ldd     temp1, Z+13
	nop
	nop
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 14. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001101
	out     PORTC, temp1
	ldd     temp1, Z+15
	nop
	nop
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 16. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001111
	out     PORTC, temp1
	ldd     temp1, Z+14
	nop
	nop
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4 

	; 15. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001110
	out     PORTC, temp1
	ldd     temp1, Z+10
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 11. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001010
	out     PORTC, temp1
	ldd     temp1, Z+11
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 12. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001011
	out     PORTC, temp1
	ldd     temp1, Z+9
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4 

	; 10. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001001
	out     PORTC, temp1
	ldd     temp1, Z+8
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	; 9. Byte
	out     PORTA, temp1

	ldi     temp1, 0b00001000
	out     PORTC, temp1
	nop
	nop
	nop
	nop
	nop
	nop
	cbi     PORTB, 4
	sbi     PORTB, 4    

	adiw    Z,16

	pop     temp1
	ret

; Ldt die Daten aus dem vorher gestezten Y-Pointer in das aktuelle Bild des SRAM
eep2ram:
	push    temp1
	push    temp2	

	ldi     ZL,LOW(Bild_akt)
	ldi     ZH,HIGH(Bild_akt)

	ldi     temp2, 0xFF                 ; 1. Schleife fr jede Platine 256Byte laden
	ldi     temp3, 0x8                  ; 2. Schleife 8 Platinen

EEPROM_read:
    sbic    EECR,EEPE                   ; prfe ob der vorherige Schreibzugriff
                                        ; beendet ist
    rjmp    EEPROM_read                 ; nein, nochmal prfen
 
    out     EEARH, YH                   ; Adresse laden
    out     EEARL, YL    
    sbi     EECR, EERE                  ; Lesevorgang aktivieren
    in      temp1, EEDR

	adiw    Y,1
	st      Z+, temp1

	dec     temp2
	brne    EEPROM_read

	dec     temp3
	brne    EEPROM_read


    pop     temp2
	pop     temp1

	ret
		   
; Pause wenn eine Zeile an ist (330us)
delayLED_on:                               
           push temp1
		   push temp2
		   ldi  temp1, 0x31
lof_loop1: ldi  temp2, 0x1A
lof_loop2: dec  temp2
		   nop
           brne lof_loop2
           dec  temp1
           brne lof_loop1
		   pop temp2
		   pop temp1
           ret

; Pause wenn eine Zeile aus ist (250us)
delayLED_off:                               
           push temp1
		   push temp2
		   ldi  temp1, 0x23
lon_loop1: ldi  temp2, 0x20
lon_loop2: dec  temp2
		   nop
           brne lon_loop2
           dec  temp1
           brne lon_loop1
		   pop temp2
		   pop temp1
           ret
